package com.nisum.offertransactionservice.config;

import feign.FeignException;
import feign.Request;
import feign.Response;
import feign.RetryableException;
import feign.codec.ErrorDecoder;
import org.springframework.http.HttpStatus;

import java.util.Date;

public class CustomErrorDecoder implements ErrorDecoder {

    private final ErrorDecoder defaultErrorDecoder = new Default();

    @Override
    public Exception decode(String methodKey, Response response) {
        Exception exception = defaultErrorDecoder.decode(methodKey, response);

        if(response.status() == HttpStatus.REQUEST_TIMEOUT.value()){
            return new RetryableException(408,"408 error", response.request().httpMethod(), new Date(),response.request());
        }
        return exception;
    }
}

