package com.nisum.offertransactionservice.client;


import com.nisum.offertransactionservice.config.OfferTransactionConfig;
import com.nisum.offertransactionservice.dto.Item;
import com.nisum.offertransactionservice.dto.PERequest;
import com.nisum.offertransactionservice.dto.PEResponse;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.core.publisher.Mono;

import java.util.ArrayList;
import java.util.List;

public class ClientServiceTest {


    @InjectMocks
    ClientService clientService;

    @Mock
    private WebClient webClientMock;

    @Mock
    private WebClient.RequestHeadersSpec requestHeadersMock;

    @Mock
    private WebClient.RequestBodySpec requestBodyMock;

    @Mock
    private WebClient.RequestBodyUriSpec requestBodyUriMock;

    @Mock
    private WebClient.ResponseSpec responseMock;

    @Mock
    OfferTransactionConfig offerTransactionConfig;


    @BeforeEach
    public void setUp() throws Exception {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    void getStringMonoTest(){
        String uuid = "86fd4146-0540-405b-b621-a95f4ccdfa0d";
        //when(offerTransactionConfig.getPeBaseUrl()).thenReturn("http://localhost:8089");
        //when(offerTransactionConfig.getSpBaseUrl()).thenReturn("http://localhost:8081");
//        when(webClientMock.post()).thenReturn(requestBodyUriMock);
//        when(requestBodyUriMock.uri("/store/producer")).thenReturn(requestBodyMock);
//        when(requestBodyMock.bodyValue(Mono.just(uuid))).thenReturn(requestHeadersMock);
//        when(requestHeadersMock.retrieve()).thenReturn(responseMock);
//        when(responseMock.bodyToMono(String.class)).thenReturn(Mono.just(uuid));
        Mono<String> stringMono = clientService.getStringMono(uuid);
        Assertions.assertNotNull(stringMono);
    }


    private PERequest getPEReq() {
        PERequest peRequest = new PERequest();
        peRequest.setHhId(123L);
        List<Item> itemList = new ArrayList<>();
        Item item1 = new Item("Coke", "12", 13.05);
        Item item2 = new Item("Thumpsup", "11", 14.05);
        itemList.add(item1);
        itemList.add(item2);
        peRequest.setItemList(itemList);
        return peRequest;
    }

    private PEResponse getPeResponse() {
        PEResponse peResponse = new PEResponse();
        peResponse.setHhid(123L);
        List<Item> itemList = new ArrayList<>();
        Item item1 = new Item("Coke", "12", 6.05);
        Item item2 = new Item("Thumpsup", "11", 12.32);
        itemList.add(item1);
        itemList.add(item2);
        peResponse.setDiscountedItemList(itemList);
        return peResponse;
    }

}
